package com.company.changes.screen.newentity;

import com.company.changes.entity.NewEntity;
import io.jmix.core.DataManager;
import io.jmix.core.LoadContext;
import io.jmix.ui.Notifications;
import io.jmix.ui.action.Action;
import io.jmix.ui.model.CollectionContainer;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.screen.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;

@UiController("NewEntity2.browse")
@UiDescriptor("new-entity2-browse.xml")
@LookupComponent("newEntitiesTable")
public class NewEntity2Browse extends StandardLookup<NewEntity> {
    private static final Logger log = LoggerFactory.getLogger(NewEntity2Browse.class);

    @Autowired
    protected DataManager dataManager;
    @Autowired
    protected CollectionLoader<NewEntity> newEntitiesDl;
    @Autowired
    protected Notifications notifications;

    @Install(to = "newEntitiesDl", target = Target.DATA_LOADER)
    private List<NewEntity> newEntitiesDlLoadDelegate(LoadContext<NewEntity> loadContext) {
        // Here you can load entities from an external store
        return initDc();
    }

    private List<NewEntity> initDc() {
        List<NewEntity> list = new ArrayList<>();
        for (int i = 0; i < 50; i++) {
            NewEntity entity = dataManager.create(NewEntity.class);
            entity.setName("name " + i);
            list.add(entity);
        }
        return list;
    }

    @Subscribe("newEntitiesTable.refresh")
    protected void onNewEntitiesTableRefresh(final Action.ActionPerformedEvent event) {
        newEntitiesDl.load();
    }

    @Subscribe(id = "newEntitiesDc", target = Target.DATA_CONTAINER)
    protected void onNewEntitiesDcItemPropertyChange(final InstanceContainer.ItemPropertyChangeEvent<NewEntity> event) {
        log.info("##-------## onNewEntitiesDcItemPropertyChange");
        notifications.create().withDescription("onNewEntitiesDcItemPropertyChange").show();
    }

    @Subscribe(id = "newEntitiesDc", target = Target.DATA_CONTAINER)
    protected void onNewEntitiesDcCollectionChange(final CollectionContainer.CollectionChangeEvent<NewEntity> event) {
        log.info("###### onNewEntitiesDcCollectionChange");
    }

    @Subscribe(id = "newEntitiesDc", target = Target.DATA_CONTAINER)
    protected void onNewEntitiesDcItemChange(final InstanceContainer.ItemChangeEvent<NewEntity> event) {
        log.info("###### onNewEntitiesDcItemChange");
    }
}